<?php
/*
 * $Id: progress_tracker.inc.php,v 1.1 2006/05/21 23:29:39 shida Exp $
 * 
 * License:  GNU General Public License
 *
 * Copyright (c) 2006 in3c.org
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 * USA.
 * 
 */

define('SHOW_ER_DEFAULT_JAVA_HOME', '/usr/share/java/j2se');
define('PLUGIN_DB_DEFAULT_CONFIGURE_FILE', 'show_er_dbconfigure');

ini_set("include_path", 
        LIB_DIR . "pear:" . ini_get("include_path"));

require_once "DB.php";

function plugin_show_er_convert()
{
    list($dbConfigureFileName) = func_get_args();

    $erViewer = new PukiWiki_Plugin_ErViewer($dbConfigureFileName);
    $result = $erViewer->init();

    if (PEAR::isError($result)) {
        return $result->getMessage();
    }

    return $erViewer->getImageUrl();
}

function plugin_show_er_action()
{

    global $vars;

    $erViewer = new PukiWiki_Plugin_ErViewer($vars['dc']);
    $result = $erViewer->init();
    if (PEAR::isError($result)) {
        echo $erViewer->getMessage();
        exit();
    }

    $erViewer->showEr();

    exit();
}

class PukiWiki_Plugin_DB extends DB{

    var $dbConfigureFileName;
    var $dbConfigure;

    function PukiWiki_Plugin_DB($dbConfigureFileName) {

        $this->dbConfigureFileName = $dbConfigureFileName;

        if(empty($this->dbConfigureFileName)) {
            $this->dbConfigureFileName = PLUGIN_DB_DEFAULT_CONFIGURE_FILE;
        }
    }

    function init() {

        $this->dbConfigure = 
            parse_ini_file(PLUGIN_DIR . $this->dbConfigureFileName . ".ini");

        if (empty($this->dbConfigure['host']) ||
            empty($this->dbConfigure['database']) ||
            empty($this->dbConfigure['user']) ||
            empty($this->dbConfigure['pass'])) {

            return PEAR::raiseError("<div>plugin db error: " . 
                                    "host, database, user or pass " . 
                                    "are not found</div>");

        }

        return true;
    }

    function getDsn() {

        return $dsn = "mysql://" . 
            $this->dbConfigure['user'] . ":" . 
            $this->dbConfigure['pass'] . "@" . 
            $this->dbConfigure['host'] . "/" . 
            $this->dbConfigure['database'];
    }

}

class PukiWiki_Plugin_ErViewer extends PukiWiki_Plugin_DB {

    var $javaHome;

    function init() {

        $result = parent::init();
        if (PEAR::isError($result)) {
            return $result;
        }

        if (empty($_SERVER['JAVA_HOME'])) {
            if (! putenv('JAVA_HOME=' . SHOW_ER_DEFAULT_JAVA_HOME)) {
                PEAR::raiseError("<div>cannot set JAVA_HOME</div>");
                return false;
            }
        }

        $this->javaHome = getenv('JAVA_HOME');

        return true;
    }

    function getImageUrl() {

        return "<img src='" . get_script_uri() . 
            "?plugin=show_er&" . 
            "dc=" . $this->dbConfigureFileName . "' />";
    }

    function showEr() {

        $command = 
            $this->javaHome . "/bin/java -jar " . 
                LIB_DIR . "db2dot/db2dot-0.2.1.jar " . 
            "driver_path=" . 
                LIB_DIR . "db2dot/mysql-connector-java-3.1.12-bin.jar " .
            "driver=com.mysql.jdbc.Driver " . 
            "url=jdbc:mysql://" . $this->dbConfigure['host'] . "/" . 
                                  $this->dbConfigure['database'] . " " . 
            "user=" . $this->dbConfigure['user'] . " " . 
            "pass=" . $this->dbConfigure['user'] . " | " . 
            "dot -Tpng -Grankdir=BT -Nshape=box " . 
            "-Earrowtail=crow -Earrowhead=none";

        header ("Content-type: image/png");
        passthru($command);
    }
}

?>
